from datetime import datetime

from django.db import models

# Create your models here.

SHARE_URL = 0
SHARE_FILE = 1

SHARE_TYPES = [
    (SHARE_URL, 'URL'),
    (SHARE_FILE, 'File')
]


class Share(models.Model):
    creator = models.ForeignKey('auth.User', verbose_name='Creator', on_delete=models.CASCADE)
    share_type = models.IntegerField(choices=SHARE_TYPES, verbose_name='Share type')
    created_on = models.DateTimeField(default=datetime.now, verbose_name='Created on',
                                      db_index=True)
    pwd_hash = models.CharField(max_length=64, verbose_name='Hashed password salt')
    # this is either an URL or a f'{UUID}.real_file_name' in /data
    resource = models.TextField(verbose_name='Resource')
    views_count = models.IntegerField(verbose_name='Amount of displays', default=0)
